<?php
// $Id: FeedsSourceCrawler.inc,v 1.1 2010/07/24 15:06:33 twistor Exp $

feeds_include('FeedsConfigurable');
feeds_include('FeedsSource');

class FeedsSourceCrawler extends FeedsSource {
  public function import() {
    try {
      if (!$this->batch || !($this->batch instanceof FeedsImportBatch)) {
        $this->batch = $this->importer->fetcher->fetch($this);
        $this->importer->parser->parse($this->batch, $this);
      }
      $this->raw = $this->batch->getRaw();
      $result = $this->importer->processor->process($this->batch, $this);
      if ($result == FEEDS_BATCH_COMPLETE) {
        unset($this->batch);
        module_invoke_all('feeds_after_import', $this->importer, $this);
      }
    }
    catch (Exception $e) {
      unset($this->batch);
      throw $e;
    }
    return $result;
  }

  public function setHTTPSource($url) {
    $this->config['FeedsHTTPFetcher']['source'] = $url;
  }

  public function getRaw() {
    return $this->raw;
  }
}
